# -*- coding:Utf-8 -*-


# ==================================================
# >> IMPORTATIONS
# ==================================================


import es
import langlib
import vecmath
import usermsg
import gamethread

import os

import psyco
psyco.full()


# ==================================================
# >> INFORMATIONS
# ==================================================


g_informations = es.AddonInfo()
g_informations["name"] = "FireBalls by L'In20Cible"
g_informations["version"] = "1.0"
g_informations["date"] = "2010-06-30"
g_informations["author"] = "L\'in20Cible"
g_informations["url"] = "http://addons.eventscripts.com/addons/view/fireballs/"
g_informations["basename"] = "fireballs"

es.ServerVar(("fireballs_version"), (g_informations["version"] + " by " + g_informations["author"])).makepublic()


# ==================================================
# >> GLOBALES
# ==================================================


g_roundisover = True
g_players = list()
g_fireballs = list()

g_options = {
   "enable"      : [1, "fireballs_enable <1/0> -- Active/Désactive les balles de feu."],
   "advert"      : [1, "fireballs_advert <1/0> -- Active/Désactive les annonces aux début de chaque round."],
   "friendlyfire": [0, "fireballs_friendlyfire <1/0> -- Active/Désactive les dommages causés par une balles de feu entre les joueurs d'une même équipe."]
   }
for option in g_options:
   g_options[option] = es.ServerVar(("fireballs_" + option), g_options[option][0], g_options[option][1])
   
eventscripts_gamedir = str(es.ServerVar("eventscripts_gamedir")).replace(os.sep, "/")


# ==================================================
# >> INITIALISATION
# ==================================================


def load():
   __init__()
   es.server.queuecmd("mp_restartgame 1")
   es.addons.registerTickListener(TickListenerCallBack)
   if es.exists("clientcommand", "fireballs"):
      return
   es.regclientcmd("fireballs", os.path.join(g_informations["basename"], "ClientCommandCallBack").replace(os.sep, "/"))
   
   
def __init__():
   global g_players, g_fireballs, g_translations
   if len(g_players):
      g_players = list()
   if len(g_fireballs):
      g_fireballs = list()
   path = GetConfigurationFilePath("configuration.cfg")
   if os.path.isfile(path):
      es.mexec(path.replace(eventscripts_gamedir, ".."))
   g_translations = TranslationFileIsMissingCallBack
   path = GetConfigurationFilePath("translations.ini")
   if not os.path.isfile(path):
      return
   g_translations = langlib.Strings(path)
   g_translations.fallback = "en"
   
   
def unload():
   es.addons.unregisterTickListener(TickListenerCallBack)
   if not es.exists("clientcommand", "fireballs"):
      return
   es.unregclientcmd("fireballs")
   
   
# ==================================================
# >> UTILITAIRES
# ==================================================


def GetConfigurationFilePath(file):
   return os.path.join(eventscripts_gamedir, "cfg", "eventscripts", g_informations["basename"], file).replace(os.sep, "/")
   
   
def GetPlayerViewCoordDistance(userid):
   returnvalue = 0.0
   entities = es.createentitylist("prop_dynamic")
   ExecutePlayerCheat(userid, "prop_dynamic_create props_c17/tv_monitor01_screen.mdl")
   for index in es.createentitylist("prop_dynamic"):
      if (index in entities):
         continue
      returnvalue = vecmath.distance(es.getplayerlocation(userid), map(float, es.entitygetvalue(index, "origin").split(" ")))
      es.setentityname(index, ("remove_" + str(index)))
      es.fire(userid, ("remove_" + str(index)), "Kill")
      break
   return returnvalue
   
   
def ExecutePlayerCheat(userid, string):
   if int(es.ServerVar("sv_cheats")):
      es.sexec(userid, string)
   else:
      es.forcevalue("sv_cheats", 1)
      es.sexec(userid, string)
      es.forcevalue("sv_cheats", 0)
      
      
def GetPlayerEyeLocation(userid):
   returnvalue = (0.0, 0.0, 0.0)
   x, y, z = es.getplayerlocation(userid)
   z = (z + 66.7)
   if (es.getplayerprop(userid, 'CBasePlayer.localdata.m_Local.m_bDucked') % 2):
      z = (z - 16.1)
   return " ".join([str(x), str(y), str(z)])
   
   
def SetPlayerFireBall(userid, entities):
   fireballs = list()
   for index in es.createentitylist("gib"):
      if (index in entities):
         continue
      fireballs.append(index)
   index = 0
   for fireball in fireballs:
      if (index == 0):
         index = fireball
      elif (index > fireball):
         index = fireball
   g_fireballs.append(index)
   gamethread.delayed(1, ExplodePlayerFireBall, (userid, index))
   es.setindexprop(index, "CBaseEntity.m_CollisionGroup", 9)
   
   
def ExplodePlayerFireBall(userid, index):
   if (index not in g_fireballs):
      return
   g_fireballs.remove(index)
   es.emitsound("entity", index, "weapons/c4/c4_explode1.wav", 1.0, 0.5)
   
   es.setentityname(index, ("gib_" + str(userid)))
   es.fire(userid, ("gib_" + str(userid)), "DispatchEffect", "Explosion")
   es.fire(userid, ("gib_" + str(userid)), "DispatchEffect", "ManHackSparks")
   es.fire(userid, ("gib_" + str(userid)), "DispatchEffect", "HelicopterMegaBomb")
   
   origin = es.entitygetvalue(index, "Origin")
   
   es.fire(userid, ("gib_" + str(userid)), "Kill")
   
   index = es.createentity("env_physexplosion", ("env_physexplosion_" + str(userid)))
   outputs = {
      "Radius"    : 250,
      "Magnitude" : 500,
      "SpawnFlags": 2,
      "Origin"    : origin
      }
   for output in outputs:
      es.entitysetvalue(index, output, outputs[output])
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Explode")
   es.fire(userid, ("env_physexplosion_" + str(userid)), "Kill")
   
   index = es.createentity("env_explosion", ("env_explosion_" + str(userid)))
   outputs = {
      "iMagnitude"     : 500,
      "RenderMode"     : 5,
      "SpawnFlags"     : 1,
      "Origin"         : origin,
      "iRadiusOverride": 250
      }
   for output in outputs:
      es.entitysetvalue(index, output, outputs[output])
   es.fire(userid, ("env_explosion_" + str(userid)), "Explode")
   es.fire(userid, ("env_explosion_" + str(userid)), "Kill")
   
   for player in es.getUseridList():
      if es.getplayerprop(player, "CBasePlayer.pl.deadflag") or ((int(g_options["friendlyfire"]) == 0) and (es.getplayerteam(userid) == es.getplayerteam(player))):
         continue
      distance = vecmath.distance(origin.replace(" ", ","), es.getplayerlocation(player))
      if (distance < 250.0):
         damage = int(250 * 100 / distance / 3)
         usermsg.shake(player, damage, 1.0)
         es.server.queuecmd(" ".join(["damage", str(player), str(damage), "32", str(userid)]))
         
         
# ==================================================
# >> FONCTIONS D'APPEL
# ==================================================


def TranslationFileIsMissingCallBack(string, tokens, language):
   return "Sorry, the translations file is missing."
   
   
def TickListenerCallBack():
   for index in es.createentitylist("gib"):
      if (es.getindexprop(index, "CBaseEntity.m_CollisionGroup") != 9):
         es.setindexprop(index, "CBaseEntity.m_CollisionGroup", 9)
   for fireball in g_fireballs:
      es.effect("smoke", es.getindexprop(fireball, "CBaseEntity.m_vecOrigin"), "smoke", 10, 0.1)
      
      
def ClientCommandCallBack():
   userid = es.getcmduserid()
   if not int(g_options["enable"]) or g_roundisover or (userid in g_players) or es.getplayerprop(userid, "CBasePlayer.pl.deadflag"):
      return
   g_players.append(userid)
   entities = es.createentitylist("gib")
   
   es.precachemodel("models/weapons/w_grenade.mdl")
   index = es.createentity("Env_Shooter", ("Env_Shooter_" + str(userid)))
   outputs = {
      "Angles"          : " ".join([str(es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[0]")), str(es.getplayerprop(userid, "CCSPlayer.m_angEyeAngles[1]")), "0.0"]),
      "m_iGibs"         : 1,
      "Delay"           : 0,
      "m_flVelocity"    : (GetPlayerViewCoordDistance(userid) * 100),
      "m_flVariance"    : 0,
      "ShootModel"      : "models/weapons/w_grenade.mdl",
      "ShootSounds"     : -1,
      "Simulation"      : 1,
      "GibAngleVelocity": 900,
      "SpawnFlags"      : 2,
      "Origin"          : GetPlayerEyeLocation(userid)
      }
   for output in outputs:
      es.entitysetvalue(index, output, outputs[output])
   es.fire(userid, ("Env_Shooter_" + str(userid)), "Shoot")
   es.fire(userid, ("Env_Shooter_" + str(userid)), "Kill,-1,0.1")
   
   es.emitsound("player", userid, "weapons/rpg/rocketfire1.wav", 1.0, 0.5)
   
   gamethread.delayed(0.1, SetPlayerFireBall, (userid, entities))
   gamethread.delayed(1.1, g_players.remove, userid)
   
   
# ==================================================
# >> ÉVÉNEMENTS
# ==================================================


def es_map_start(event_var):
   __init__()
   
   
def round_end(event_var):
   global g_roundisover
   g_roundisover = True
   
   
def round_freeze_end(event_var):
   global g_roundisover
   g_roundisover = False
   if not int(g_options["advert"]):
      return
   for userid in es.getUseridList():
      if es.isbot(userid):
         continue
      es.tell(userid, "#multi", ("#green[FireBalls] #default" + g_translations("advert", dict(), langlib.getLangAbbreviation(es.getclientvar(userid, "cl_language")))))